program testclient;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}
  cthreads,
  {$ENDIF}
  Classes
  { you can add units after this }, sysutils, systemlog, dynlibs;


//procedure InitTest(); cdecl; external 'libtestlib.so' name 'InitTest';
//procedure FinalizeTest(); cdecl; external 'libtestlib.so' name 'FinalizeTest';
//function Test(ACounter: Integer; AJSON: PChar):PChar;cdecl; external 'libtestlib.so' name 'Test';

var
  Lib: TLibHandle=0;

var
  InitTest: procedure(); cdecl;
  FinalizeTest: procedure(); cdecl;
  Test: procedure(ACounter: Integer; AJSON: PChar); cdecl;
  i: Integer;
  th: TThread;

type

  { TTestThread }

  TTestThread = class(TThread)
  private
    FCounter: Integer;
  protected
    procedure Execute; override;
  public
    property Counter: Integer read FCounter write FCounter;
  end;

{ TTestThread }

procedure TTestThread.Execute;
begin
  try
    Test(FCounter, PChar('{"1" : '+IntToStr(FCounter)+', "2" : "test'+IntToStr(FCounter)+'"}'));
  except on e: Exception do
    syslog(LOG_INFO, 'Thread error: %s', [PChar(e.Message)]);
  end;
end;

begin

  Lib := LoadLibrary('./libtestlib.so');
  if Lib=dynlibs.NilHandle then
    raise Exception.Create('Error: '+dynlibs.GetLoadErrorStr);
  try
    // Get adresses
    Pointer(InitTest) := GetProcedureAddress(Lib, 'InitTest');
    if InitTest=nil then
      raise Exception.Create('Could not get handle to InitTest() function');
    Pointer(FinalizeTest) := GetProcedureAddress(Lib, 'FinalizeTest');
    if FinalizeTest=nil then
      raise Exception.Create('Could not get handle to FinalizeTest() function');
    Pointer(Test) := GetProcedureAddress(Lib, 'Test');
    if Test=nil then
      raise Exception.Create('Could not get handle to Test() function');


    InitTest();

    for i:=1 to 10 do
    begin
      th := TTestThread.Create(True);
      TTestThread(th).Counter := i;
      th.FreeOnTerminate := True;
      th.Start;
      //sleep(500);
    end;
    Sleep(5000); // wait for threads terminate
  finally
    FinalizeTest();
    UnloadLibrary(Lib);
  end;
end.

