unit testlibu;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils;

procedure InitTest(); cdecl;
procedure FinalizeTest(); cdecl;
procedure Test(ACounter: Integer; AJson: PChar); cdecl;

implementation

uses systemlog, jsonparser, fpjson;

procedure InitTest; cdecl;
begin
  //InitCriticalSection(GlobalCS);
  syslog(log_info, '------NEW-----', []);
  HookSignal(RTL_SIGDEFAULT);
end;

procedure FinalizeTest; cdecl;
begin
  //DoneCriticalsection(GlobalCS);
  //UnhookSignal(RTL_SIGDEFAULT);
end;

procedure Test(ACounter: Integer; AJson: PChar); cdecl;
var
  js: TJSONObject=nil;
  jp: TJSONParser=nil;
  i: Integer;
  s: String;
begin
  syslog(log_info, 'Enter: %d', [ACounter]);
  try try
    jp := TJSONParser.Create(AJson);
    js := TJSONObject(jp.Parse);
    FreeAndNil(jp);
    Sleep(500);
    i := js.Get('1', -1);
    Sleep(500);
    s := js.Get('2', '');
    syslog(log_info, 'Got %d: %d %s', [ACounter, i, pchar(s)]);
  except on e: Exception do
    begin
      syslog(log_info, 'Error: %s', [PChar(e.Message)]);
      raise;
    end;
  end;
  finally
    FreeAndNil(jp);
    FreeAndNil(js);
    syslog(log_info, 'Leave: %d', [ACounter]);
  end;
end;

end.

